﻿using System;
using NationalInstruments.VisaNS;

namespace Example1
{
    class Program
    {
        static void Main(string[] args)
        {
            //VXI-11 Connection string
            string sAddress = "TCPIP0::10.0.1.196::INSTR";

            //The VNA uses a message based session
            MessageBasedSession mbSession = null;
            //But we'll just open a generic Session first
            Session mySession = null;

            //response string
            string responseString = null;

            try
            {
                //open a Session to the VNA
                mySession = ResourceManager.GetLocalManager().Open(sAddress);
                //cast this to a message based session
                mbSession = (MessageBasedSession)mySession;
                //Send "*IDN?" command
                mbSession.Write("*IDN?\n");
                //Read the response
                responseString = mbSession.ReadString();

                //Write to Console
                Console.WriteLine("Response to *IDN?:");
                Console.WriteLine(responseString);
                
                //Return to Local Control
                mbSession.Write("RTL\n");
                //Close the Session
                mbSession.Dispose();

            }
            catch (VisaException v_exp)
            {
                Console.WriteLine("Visa caught an error!!");
                Console.WriteLine(v_exp.Message);
            }
            catch (Exception exp)
            {
                Console.WriteLine("Something didn't work!!");
                Console.WriteLine(exp.Message);
                Console.WriteLine();
            }

            keepConsoleUp();
        }

        private static void keepConsoleUp()
        {
            Console.WriteLine("");
            Console.WriteLine("Enter to Continue");
            Console.ReadLine();
        }
    }
}
